Attribute VB_Name = "stdRoutines"
'' This module contains some standard functions that can be custom tailored for any application

Option Explicit

Public Sub Delay(DelayTime As Single)
'' This routine will delay for the specified number of seconds
'' Input:
''  DelayTime - time to delay in seconds

   Dim Finish As Single
   Finish = Timer() + DelayTime
   Do
   Loop Until Finish <= Timer()
End Sub

Public Sub appendFile(data() As Variant, filename As String, nresults As Long, count As Long, timey As Double, samp As Double)
'' This routine will append data to a file
'' Inputs:
''  data - the data to be appended
''  filename - the name of the file to append the data to
''  nresults - the number of entries in each line of data
''  count - the total count of how many rows of entries have been made
''  timey -  the total time that the data has been logged
''  samp - the sample rate

    Dim writeStuff() As Variant
    Dim i, uppy, compRows, index As Integer
    
    writeStuff = data
    uppy = UBound(writeStuff)
    ReDim Preserve writeStuff(uppy)
    compRows = Int(uppy / nresults)
    index = 0
    
    Open filename For Append As #1
        For i = 1 To compRows
            count = count + 1
            timey = timey + samp
            If nresults = 6 Then
                Write #1, count, timey, writeStuff(index), writeStuff(index + 1), writeStuff(index + 2), writeStuff(index + 3), writeStuff(index + 4), writeStuff(index + 5)
                index = index + 6
            ElseIf nresults = 4 Then
                Write #1, count, timey, writeStuff(index), writeStuff(index + 1), writeStuff(index + 2), writeStuff(index + 3)
                index = index + 4
            ElseIf nresults = 3 Then
                Write #1, count, timey, writeStuff(index), writeStuff(index + 1), writeStuff(index + 2)
                index = index + 3
            ElseIf nresults = 2 Then
                Write #1, count, timey, writeStuff(index), writeStuff(index + 1)
                index = index + 2
            ElseIf nresults = 1 Then
                Write #1, count, timey, writeStuff(index)
                index = index + 1
            Else
                MsgBox "ERROR!"
            End If
            
        Next i
           
    Close #1
     
End Sub

Public Function initialize_file(modelInfo As Boolean, logV As Boolean, logI As Boolean, logVmax As Boolean, logImax As Boolean, parameters As Long, data() As String, filename As String)
'' This Function will initialize a file to datalog to.  This also determines if the parameters will make a valid datalog.
'' Inputs:
''  modelInfo - is the model a Precision DC Power Supply or not
''  logV - is voltage logging on?
''  logI - is current logging on?
''  logVmax - is voltage max/min datalogging on?
''  logImax - is current max/min logging on?
''  parameters - how many parameters are being logged
''  filename - the file that data will be logged to
'' Output:
''   1 if the initialize passes, 0 if it fails

    Dim writeStuff() As String
    Dim i As Integer
    On Error GoTo fileerr
    
    If logV = True And logI = False And logVmax = False And logImax = False Then
        data(3) = "Sample, Time,Average Voltage"
        parameters = 1
        initialize_file = 0
    ElseIf logV = False And logI = True And logVmax = False And logImax = False Then
        data(3) = "Sample, Time,Average Current"
        parameters = 1
        initialize_file = 0
    ElseIf logV = True And logI = False And logVmax = True And logImax = False Then
        data(3) = "Sample, Time,Average Voltage,Min Voltage, Max Voltage"
        parameters = 3
        initialize_file = 0
    ElseIf logV = False And logI = True And logVmax = False And logImax = True Then
        data(3) = "Sample, Time,Average Current,Min Current, Max Current"
        parameters = 3
        initialize_file = 0
    ElseIf logV = True And logI = True And logVmax = False And logImax = False And modelInfo = True Then
        data(3) = "Sample, Time,Average Current,Average Voltage"
        parameters = 2
        initialize_file = 0
    ElseIf logV = True And logI = True And logVmax = True And logImax = False And modelInfo = True Then
        data(3) = "Sample, Time,Average Current,Average Voltage,Min Voltage, Max Voltage"
        parameters = 4
        initialize_file = 0
    ElseIf logV = True And logI = True And logVmax = False And logImax = True And modelInfo = True Then
        data(3) = "Sample, Time,Average Current,Min Current, Max Current,Average Voltage"
        parameters = 4
        initialize_file = 0
    ElseIf logV = True And logI = True And logVmax = True And logImax = True And modelInfo = True Then
        data(3) = "Sample, Time,Average Current,Min Current, Max Current,Average Voltage,Min Voltage, Max Voltage"
        parameters = 6
        initialize_file = 0
    Else
        MsgBox "The combination of items you want to datalog is not valid.  Please reselect and start over"
        initialize_file = 1
        Exit Function
    End If
    
    writeStuff = data
    
    ReDim Preserve writeStuff(UBound(writeStuff))

    
    Open filename For Output As #1
        For i = 0 To UBound(writeStuff)
            Print #1, , writeStuff(i)
        Next i
    Close #1
    Exit Function
fileerr:
    MsgBox "Invalid file.  Please rename!"
End Function

